10   'KEPLER: This program computes the path of a particle moving according to                Newton's law of gravitation.
11 '
14 'Initialization of variables and data input.
20  DEFINT I-N
30 DIM R(300),  V(300), TT(300), PH(300), IX(300), IY(300)
35 DIM XX(300), YY(300)
40 INPUT "INITIAL SPEED: 1.0 = CIRCLE  ", VZSTR : INPUT "TIME INTERVAL =";DEL  
60 INPUT "HOW OFTEN SHOULD POSITION BE REPORTED?";N
70 INPUT "hOW MANY POSITIONS SHOULD BE REPORTED?";M
80 INPUT "DO YOU WANT OUTPUT PRINTED ON PAPER? Y OR N";P$
90 INPUT "SET SCALE FACTOR FOR PLOTTING. 1 WORKS WELL FOR A CIRCLE.";S
95 INPUT "CHOOSE THE ANGLE BETWEEN PLOTTED VELOCITY VECTORS (DEGREES)";VANG  
110 J=0 : THTN=0 : PI=3.141592659# : PHIN=PI/2 : RN=1! : VN = VZSTR : VANG = VANG*PI/180  
120 VX = 0! : VY = VN
130 X = RN : Y = 0!
1000 '
1010 'Print out the input data.
1015 PRINT "VN      DEL": PRINT USING "#.###   ";VN,DEL
1020 IF P$="Y" OR P$="y" THEN LPRINT "VN      DEL"
1025 IF P$="y" OR P$="Y" THEN LPRINT USING "#.###   ";VN,DEL
1040 PRINT "INTERVAL     NUMBER OF REPORTS" : PRINT USING "##          ";N,M
1045 IF P$="Y" OR P$="y" THEN LPRINT "INTERVAL      NUMBER OF REPORTS"
1046 IF P$ = "Y" OR P$ = "y" THEN LPRINT USING "##        ";N,M
1060 PRINT "  RADIUS    ANGLE    VELOCITY   ANGLE" 
1070 IF (P$="Y") OR (P$="y") THEN LPRINT "  RADIUS    ANGLE    VELOCITY   ANGLE3
2000 '3
2010 ' Calculate increments in position and velocity using Newton's3
2020 ' Law of Gravity and kinematics.3
2025 I=0
2030 ' Distance moved3
2040 DRN=VN*DEL : ANG=PHIN-THTN 
2055 'CALCULATE NEW VELOCITY COMPONENTS
2056 DVX = (-X/(RN*RN*RN))*DEL : DVY = (-Y/(RN*RN*RN))*DEL
2058 VX = VX +DVX : VY = VY + DVY
2060 ' new distance from origin, and new angular coordinate.3
2062 DX = VX*DEL:  DY = VY*DEL
2065 X=X + DX:  Y = Y+DY
2070 RQ=SQR(X*X+Y*Y) : THTQ=ATN(Y/X)
2075 IF Y > 0! AND X < 0! THEN THTQ = THTQ + PI
2076 IF Y < 0! AND X < 0! THEN THTQ = THTQ + PI
2080 ' NEW VELOCITY AND DIRECTION OF VELOCITY'
2090 VQ = SQR(VX*VX + VY*VY)
2100 ' change in radial velocity, new speed, and new direction of velocity.3
2110 IF VX=0 THEN PHIQ = PI*((1!-SGN(VY))/2+.5) ELSE PHIQ = ATN(VY/VX)
2120 IF VY > 0! AND VX < 0! THEN PHIQ = PHIQ + PI
2125 IF VY < 0! AND VX < 0! THEN PHIQ = PHIQ + PI
2160 '3
3000 ' update variables.3
3010 I=I+1 : RN=RQ : THTN=THTQ : VN=VQ : PHIN=PHIQ 
3060 IF I=>N GOTO 4020  
3070 GOTO 2040  
3080 '3
4000 ' Fill arrays for plotting and convert angles in radians to degrees3
4010 ' for printing.3
4020 J=J+1 : R(J)=RQ : TT(J)=THTQ : THT=THTQ*180/PI : V(J)=VQ : PH(J)=PHIQ 
4025 XX(J) = X:  YY(J) = Y
4080 PHI=PHIQ*180/PI 
4090  PRINT USING " ###.###  ";R(J),THT,V(J),PHI,XX(J),YY(J)
4100 IF (P$="Y") OR (P$="y") THEN LPRINT USING " ###.###  ";R(J),THT,V(J),PHI 
4110 '3
5000 ' If finished, plot, otherwise compute new increments.3
5010 ' IF YOU DO NOT WISH TO PLOT RESULTS, REPLACE STATEMENT 5030 WITH END
5020 IF J < M GOTO 2025  
5030 ' Prepare screen for plot.3
5040 SCREEN 2,0,0,0:CLS:KEY OFF 
5050 ' Label with initial data.3
5060 PRINT "VZSTR    DEL" : PRINT USING "#.###   ";VZSTR,DEL 
5080 PRINT "INTERVAL     NUMBER OF REPORTS" : PRINT USING "###          ";N,M 
5100 PRINT "SCALE FACTOR" : PRINT USING "#.##";S 
5200 ' Set position of origin, convert to integer.3
5210 XO=630-100*S: IXC = CINT(XO)
5220 ' Mark position of gravitating object.
5230 CIRCLE (IXC,100),5 : PSET (IXC,100)
5250 ' Initial position.3
5260 IXZ=630: IYZ = 100  
5300 ' Move from one position to the next, drawing orbit.3
5310 FOR J=1 TO M STEP 1  
5320 IX(J) = IXZ : IY(J) = IYZ : XN=50*XX(J)*S
5340 IXN=2*CINT(XN)+630-100*S : YN=50*YY(J)*S : IYN=100-CINT(YN)
5370 ' If point is off the page, skip to next point.3
5380 IF IXN=>640 OR IXN=<0 GOTO 5520 : IF IYN=<0 OR IYN=>200 GOTO 5520  
5400 LINE (IXZ,IYZ) - (IXN,IYN) : IXZ=IXN : IYZ = IYN : NEXT J 
5500 'Strike any key to draw velocity vectors.3
5505 K$=INKEY$: IF K$="" THEN 5505
5510 VPL = -1*VANG -1  
5520 FOR J = 1 TO M STEP 1  
5530 IF PH(J) - VPL < VANG GOTO 5610
5540 VP = 30*V(J)*S : IV = CINT(VP) : IXZ = IX(J): IYZ = IY(J) 
5560 AV = PH(J)*180/PI : IAV = CINT(AV)-90 : IT = IAV-45 : IB = IAV+45  
5570 IF IAV<315 THEN GOTO 5580 ELSE IB=IB-360:IF IAV>360 THEN IAV=IAV-360  
5580 PSET(IXZ,IYZ) 
5590 DRAW "ta=iAV; U=IV; TA=IT;ND5 TA=IB;ND5 " 
5600 VPL = PH(J)
5610 NEXT J
5620 '3
6000 ' Strike any key to erase display and end program.3
6010 K$=INKEY$: IF K$="" THEN 6010  
6030 SCREEN 0,0,0,0: KEY ON 
6040 END 
