100   DIM IK(10), JK(10)
130   DIM B(10, 10): REM the matrix
1000 REM matrix inversion test program: setup
1010   DEFINT I-N
1020   INPUT "size of matrix" ; N
2000 REM matrix inversion test program: main part
2010   FOR I = 1 TO N
2020     FOR J = 1 TO N
2029 PRINT "next element B(I,j) i = "I" J = " J
2030   INPUT "value = " ; B(I,J)
2040     NEXT J
2050   NEXT I
2060   PRINT "initial matrix..."
2070   GOSUB 6000: REM print the matrix
2080   GOSUB 3000: REM invert the matrix
2090   PRINT "inverted matrix..."
2100   GOSUB 6000: REM print the matrix
2110   GOSUB 3000: REM invert the matrix
2120   PRINT "reinverted matrix..."
2130   GOSUB 6000: REM print the matrix
2140 END
3000 REM matrix inversion using Gauss-Jordan method
3030   DET = 1!
3040   FOR K = 1 TO N
3050     BIG = 0!
3060     FOR I = K TO N
3070       FOR J = K TO N: REM find biggest element}
3080         IF ABS(BIG) > ABS(B(I, J)) THEN GOTO 3130
3090            BIG = B(I, J)
3100            IK(K) = I
3110            JK(K) = J
3130       NEXT J
3135     NEXT I
3140     IF (BIG = 0!) THEN GOTO 3800
3180     I = IK(K)
3190    IF I <= K THEN GOTO 3250
3195                FOR J = 1 TO N : REM EXCHANge rows
3200                   SVE = B(K,J)
3210                   B(K, J) = B(I, J)
3220                   B(I, J) = -SVE
3230                 NEXT J
3250     J = JK(K)
3260    IF J <= K THEN GOTO 3330
3270                FOR I = 1 TO N : REM  EXCHANGE COLUMNS
3280                   SVE = B(I, K)
3290                   B(I, K) = B(I, J)
3300                   B(I, J) = -SVE
3310                 NEXT I
3330     FOR I = 1 TO N: REM now build the inverse
3340       IF I <> K THEN B(I, K) = -B(I, K) / BIG
3370     NEXT I
3380     FOR I = 1 TO N
3390       FOR J = 1 TO N
3400         IF I <> K AND J <> K THEN B(I, J) = B(I, J) + B(I, K) * B(K, J)
3430       NEXT J
3440     NEXT I
3450     FOR J = 1 TO N
3460       IF J <> K THEN B(K, J) = B(K, J) / BIG
3490     NEXT J
3500     B(K, K) = 1! / BIG
3510     DET = DET * BIG: REM dynamic range bomb point
3520   NEXT K
3530   FOR L = 1 TO N: REM restore the ordering of B
3540     K = N - L + 1
3550     J = IK(K)
3560     IF J < K THEN GOTO 3620
3565     FOR I = 1 TO N
3570                   SVE = B(I, K)
3580                   B(I, K) = -B(I, J)
3590                   B(I, J) = SVE
3600                 NEXT I
3620     I = JK(K)
3630     IF I < K THEN GOTO 3690
3635     FOR J = 1 TO N
3640                   SVE = B(K, J)
3650                   B(K, J) = -B(I, J)
3660                   B(I, J) = SVE
3670                 NEXT J
3690   NEXT L
3700 RETURN
3800     DET = 0
3810     RETURN
6000 REM print the matrix
6010 FOR I = 1 TO N
6020   FOR J = 1 TO N
6030     PRINT USING "####.####"; B(I, J);
6040   NEXT J
6050 PRINT
6060 NEXT I
6070 RETURN
